/**
 * Copyright (c) 2015-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 */

'use strict';

const addParamsToDefineCall = require('../../../lib/addParamsToDefineCall');
const path = require('path');








function wrapModule(module, options) {
  if (module.output.type === 'script') {
    return module.output.code;
  }

  const moduleId = options.createModuleId(module.path);
  const params = [
  moduleId,
  Array.from(module.dependencies.values()).map(options.createModuleId)];


  // Add the module name as the last parameter (to make it easier to do
  // requires by name when debugging).
  // TODO (t26853986): Switch this to use the relative file path (once we have
  // as single project root).
  if (options.dev) {
    params.push(path.basename(module.path));
  }

  return addParamsToDefineCall.apply(undefined, [module.output.code].concat(params));
}

module.exports = {
  wrapModule };