/**
 * Copyright (c) 2015-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 */

'use strict';function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];return arr2;} else {return Array.from(arr);}}

const getAppendScripts = require('../../lib/getAppendScripts');
const fs = require('fs');var _require =

require('./helpers/js');const wrapModule = _require.wrapModule;













function plainJSBundle(
entryPoint,
pre,
graph,
options)
{
  for (const module of graph.dependencies.values()) {
    options.createModuleId(module.path);
  }

  let commonModuleMapping = {};
  if (fs.existsSync('./commonModule.json')) {
    commonModuleMapping = JSON.parse(fs.readFileSync('./commonModule.json'));
  }

  return [].concat(_toConsumableArray(
  pre), _toConsumableArray(
  graph.dependencies.values()), _toConsumableArray(
  getAppendScripts(entryPoint, graph, options))).

  map(module => {
    const result = wrapModule(module, options);
    const id = options.createModuleId(module.path);
    // 过滤公共模块
    if (commonModuleMapping[id] && module.output && (module.output.type === 'module' || module.output.type === 'script')) {
      return '';
    } else {
      return result;
    }
  }).
  filter(v => v).
  join('\n');
}

module.exports = plainJSBundle;